/*
 * segatex SELinux tool.
 *
 * Copyright (C) 2007 Shintaro Fujiwara 
 * shintaro.fujiwara@gmai.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * */

#include <qlayout.h>
#include <qpushbutton.h>
#include <qlineedit.h>
//for getuid
#include <unistd.h>
#include <sys/types.h>
#include <pwd.h>

#include "segatex_login.h"

//#include <iostream>
//using namespace std;

//default constructor
SegatexLogin::SegatexLogin(QWidget *parent, const char *name): QDialog(parent, name)
{

}
unsigned long  SegatexLogin::getuid_uid_value()
{
	struct passwd *passwd; /* man getpwuid */
	unsigned long uid_value;
	passwd = getpwuid ( getuid()); /* Get the uid of the running processand use it to get a record from /etc/passwd */
	uid_value = (unsigned long) getpwuid(getuid())->pw_uid;
	/*
	printf("\n The Real User Name is %s ", passwd->pw_gecos);
	printf("\n The Login Name is %s ", passwd->pw_name);
	printf("\n The Home Directory is %s", passwd->pw_dir);
	printf("\n The Login Shell is %s ", passwd->pw_shell);
	printf("\n The Passwd is %s ", getpwuid(getuid()) >pw_passwd);
	printf("\n The uid is %lu ", (unsigned long) getpwuid(getuid())->pw_uid);
	printf("\n The gid is %lu \n\n", (unsigned long) getpwuid(getuid())->pw_gid);
	*/
	//cout << "getuid_uid_value" << uid_value << endl;

	return uid_value;
}
const QString SegatexLogin::getuid_str()
{
	struct passwd *passwd; /* man getpwuid */
	linuxuser_str ="testuser";
	passwd = getpwuid ( getuid()); /* Get the uid of the running processand use it to get a record from /etc/passwd */
	linuxuser_str = passwd->pw_name;
	/*
	printf("\n The Real User Name is %s ", passwd->pw_gecos);
	printf("\n The Login Name is %s ", passwd->pw_name);
	printf("\n The Home Directory is %s", passwd->pw_dir);
	printf("\n The Login Shell is %s ", passwd->pw_shell);
	printf("\n The Passwd is %s ", getpwuid(getuid()) >pw_passwd);
	printf("\n The uid is %lu ", (unsigned long) getpwuid(getuid())->pw_uid);
	printf("\n The gid is %lu \n\n", (unsigned long) getpwuid(getuid())->pw_gid);
	*/

	return linuxuser_str;
}
const QString SegatexLogin::seuser_and_level_for_linuxuser()
{
	/*       extern int getseuserbyname(const char *linuxuser, char **seuser,
					   char **level);
	*/
	linuxuser_tmp = getuid_str();
	const char *linuxuser;
	linuxuser = (const char *)linuxuser_tmp;
	char *seuser="test";
	char *level="test";
	char **seuser_ptr= &seuser;
	char **level_ptr= &level;

	getseuserbyname(linuxuser,seuser_ptr,level_ptr);

	linuxuser_echo = linuxuser;
	seuser_str = seuser;
	level_str = level;
	seuser_and_level_for_linuxuser_str = linuxuser_echo + ":" + seuser_str + ":" + level_str;
	//cout << "seuser_and_level_for_linuxuser_str:" << seuser_and_level_for_linuxuser_str << endl;

	return seuser_and_level_for_linuxuser_str;
}
